local PrattleRelease="r180108a" 

local Me=CreateFrame("Frame","PrattleMaster")
Me:SetScript("OnEvent",function(this,event,arg1,arg2,arg3,arg4) Me:OnEvent(event,arg1,arg2,arg3,arg4) end)
Me:RegisterEvent("VARIABLES_LOADED")

-- -------------------------------
-- DB-Init
-- -------------------------------
PrattleDB={
	INITDONE={},
	PERSONS={
		["Zifnâb"]={comment="hat PrattleMaster zusammengehämmert",}, -- im Array des jeweiligen Chars steht außer dem comment ggf. ["playername"]="FRIEND|ENEMY|usercategory"
	},
	NOSEXFOUND={},
	ALLTIME=0,
}
PrattleDBpC={
	reactOn={
		FIRE=100,FISHING=50,HERBAL=60,MINING=60,SKINNING=60,RESTSTONE=100,TELEPORT=100,PORTAL=100,RESURRECT=100, 
		PETATTACK=100,PETFOLLOW=100,PETSTAY=100,PETPASSIVE=100, PETSUMMON=100, PETDISMISS=100,
	},
	PET={},
	LASTTARGETS={},
}

-- -------------------------------
-- Variablenzuweisungen
-- -------------------------------
local L={}
local debug={}
local ElapsedTime=0.0
local lastALLTIMEupdate=0.0
local alltime0=0
local Schedules={{99999999.9,"",""}}
local playername=UnitName("player")
local dummy,playerclass=UnitClass("player")
local defaultPrattleDB=PrattleDB
local defaultPrattleDBpC=PrattleDBpC
local lasttarget=0
local setcreature=nil
local GUI=nil
local sound={["SOULSTONEOUT"]=SOUNDKIT.RAID_WARNING,["ERROR"]=SOUNDKIT.GM_CHAT_WARNING,["REMINDER"]=SOUNDKIT.LFG_REWARDS,["BOING"]=800} -- 800=GS_LOGIN, funzt mit Namen aber nicht

function Me:getRelease() return PrattleRelease end

-- -------------------------------
-- ON EVENT
-- -------------------------------
function Me:OnEvent(event,arg1,arg2,arg3,arg4)
	if event=="CURSOR_CHANGED" then Me:CURSOR_CHANGED(arg1,arg2,arg3,arg4)
	elseif event=="PLAYER_TARGET_CHANGED" then Me:PLAYER_TARGET_CHANGED(arg1,arg2,arg3,arg4)
	elseif event=="UNIT_SPELLCAST_START" then Me:UNIT_SPELLCAST_START(arg1,arg2,arg3,arg4)
	elseif event=="UNIT_SPELLCAST_CHANNEL_START" then Me:UNIT_SPELLCAST_CHANNEL_START(arg1,arg2,arg3,arg4)
	elseif event=="UNIT_SPELLCAST_CHANNEL_STOP" then Me:UNIT_SPELLCAST_CHANNEL_STOP(arg1,arg2,arg3,arg4)
	elseif event=="UNIT_SPELLCAST_SUCCEEDED" then Me:UNIT_SPELLCAST_SUCCEEDED(arg1,arg2,arg3,arg4)
	elseif event=="PLAYER_REGEN_DISABLED" then Me:PLAYER_REGEN_DISABLED(arg1,arg2,arg3,arg4)
	elseif event=="PLAYER_REGEN_ENABLED" then Me:PLAYER_REGEN_ENABLED(arg1,arg2,arg3,arg4)
	elseif event=="VARIABLES_LOADED" then Me:VARIABLES_LOADED()
	end
end

-- -----------------------------------------------------------------
-- INITIALISIERUNG
-- -----------------------------------------------------------------
function Me:VARIABLES_LOADED()
	L=Lang.Prattle
	-- Für Events registrieren
	Me:RegisterEvent("PLAYER_TARGET_CHANGED")
	Me:RegisterEvent("UNIT_SPELLCAST_START")
	Me:RegisterEvent("UNIT_SPELLCAST_CHANNEL_START")
	Me:RegisterEvent("UNIT_SPELLCAST_CHANNEL_STOP")
	Me:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	Me:RegisterEvent("PLAYER_REGEN_DISABLED")
	Me:RegisterEvent("PLAYER_REGEN_ENABLED")
	-- Scheduler initialisieren und warten, dass auch Language-File geladen ist
	Me:SetScript("OnUpdate",function(caller,elapsed) Me:Scheduler(caller,elapsed) end)
--	Me:Scheduler()
	Me:CheckReady()
end

function Me:CheckReady()
	if GetDefaultLanguage("player") and GetNumLanguages() then 
		if L["Void"]==nil then
			if Lang.Prattle then 
				L=Lang.Prattle
			else
				Me:Print("failure to load language data for "..GetLocale(),nil,"ERROR")
			end
		end
		Me:Initialize()
		-- Slash-Kommandos definieren
		SLASH_PRATTLE1 = "/prattle"
		SLASH_PRATTLE2 = "/pm"
		SlashCmdList["PRATTLE"]=function (cmd) Me:Slash(cmd) end
	else 
		Me:Print("waiting to initialize...")
		Me:AddSchedule(1,"Me:CheckReady()") 
	end
end

function Me:Initialize()
	-- EMOTOR Tabelle laden/aktualisieren
	if not PrattleDB.emotor or not PrattleDB.INITDONE[playername] then 
		if not PrattleDB.emotor then PrattleDB.emotor=L.emotor 
		else Me:Print(Me:gsub(L.msg.reinitselect,"<by>",PrattleDB.INITDONE.BY or "???"),nil,"ERROR") end
		for tbl,ttable in pairs(PrattleDB.emotor) do
			for cat,ctable in pairs(ttable) do
				for es,txtable in pairs(ctable) do
					if cat~="internal" then 
						for t=1,#PrattleDB.emotor[tbl][cat][es],1 do -- Default: Alle Texte auswählen
							PrattleDB.emotor[tbl][cat][es][t][playername]=1 
						end
					end
				end
			end
		end
		PrattleDB.INITDONE[playername]=true
		if not PrattleDB.INITDONE.BY then PrattleDB.INITDONE.BY=playername end
	else
		-- Nur komplette Listen werden eingefügt, nicht ggf. neu definierte Zielgruppen oder Texte
		for key,value in pairs(L.emotor) do
			if PrattleDB.emotor[key]==nil then 
				PrattleDB.emotor[key]=value
				Me:Print(Me:gsub(L.msg.newtable,"<table>",key))
			else
				-- "internal" wird komplett neu überommen
				PrattleDB.emotor[key].internal=L.emotor[key].internal
			end
		end
	end
	-- HE-SHE-IT Tabelle laden/aktualisieren
	if not PrattleDB.HeSheIt then PrattleDB.HeSheIt=L.HeSheIt
	else
		for key,value in pairs(L.HeSheIt) do
			if PrattleDB.HeSheIt[key]==nil then
				PrattleDB.HeSheIt[key]=value
				Me:Print(Me:gsub(L.msg.newhsi,"<key>",value[1]))
			end
		end
	end
	-- ggf. weitere Tabellen und ggf. Untertabellen werden übernommen sofern nicht vorhanden
	for key,value in pairs(defaultPrattleDB) do
		if PrattleDB[key]==nil then
			PrattleDB[key]=value
			Me:Print(Me:gsub(L.msg.newkey,"<key>",key))
		elseif type(value)=="table" then
			for ikey,ivalue in pairs(value) do
				if PrattleDB[key][ikey]==nil then
					PrattleDB[key][ikey]=ivalue
					Me:Print(Me:gsub(Me:gsub(L.msg.newikey,"<table>",key),"<key>",ikey))
				end
			end
		end
	end

	-- DB per Char aktualisieren
	for key,value in pairs(defaultPrattleDBpC) do
		if PrattleDBpC[key]==nil then
			PrattleDBpC[key]=value
			Me:Print(Me:gsub(L.msg.newpckey,"<key>",key))
		elseif type(value)=="table" then
			for ikey,ivalue in pairs(value) do
				if PrattleDBpC[key][ikey]==nil then
					PrattleDBpC[key][ikey]=ivalue
					Me:Print(Me:gsub(Me:gsub(L.msg.newpcikey,"<table>",key),"<key>",ikey))
				end
			end
		end
	end

	for name,data in pairs(PrattleDBpC.LASTTARGETS) do
			if PrattleDB.ALLTIME-(data.last or 0)>36000 then -- älter als 10 Stunden Onlinezeit?
				Me:Debug(Me:gsub(L.msg.deltarget,"<name>",name))
				PrattleDBpC.LASTTARGETS[name]=nil
		end
	end
	
	for name,data in pairs(PrattleDB.NOSEXFOUND) do 
		if not Me:GetSex(name,"initcheck") then
			if PrattleDB.ALLTIME-(data.last or 0)>72000 then -- älter als 20 Stunden Onlinezeit?
				Me:Debug(Me:gsub(L.msg.deltarget,"<name>",name))
				PrattleDB.NOSEXFOUND[name]=nil
			end
		end
	end

	Me:Print(Me:gsub(L.msg.initmsg,"<release>",PrattleRelease))
	GUI=PrattleGUI:initialize(Me,L)
end

-- -----------------------------------------------------------------
-- SCHEDULER
-- -----------------------------------------------------------------
function Me:Scheduler(caller,elapsed)
		ElapsedTime=ElapsedTime+elapsed
		if ElapsedTime>lastALLTIMEupdate+1 then
			if PrattleDB.ALLTIME then
				PrattleDB.ALLTIME=PrattleDB.ALLTIME+ElapsedTime-lastALLTIMEupdate
				lastALLTIMEupdate=ElapsedTime
			end
		end
		if debug.scheduler then
			debug.schedule.calls=1+(debug.schedule.calls or 0)
			if debug.schedule.calls%200==0 then Me:Debug("Scheduler called "..debug.schedule.calls.." times in "..format("%u",(ElapsedTime-debug.schedule.begin)).." seconds") end
		end
		if Schedules[1][1]<=ElapsedTime then
			local command=gsub(Schedules[1][2],"Me:","PrattleMaster:") -- Me: ersetzt durch global Namen, weil manchmal "unknown global 'Me'" kommt
			if debug.scheduler then Me:Debug("Scheduler elapsed at "..Schedules[1][1]..", cmd='"..command.."'") end
			tremove(Schedules,1)
			assert(loadstring(command))()
		end
		if setcreature then
			if UnitName("pet") then
				PrattleDBpC.PET[setcreature]=UnitName("pet")
				if debug.cast then Me:Debug("creature name of "..setcreature.." is "..(PrattleDBpC.PET[setcreature] or "nil")) end
				setcreature=nil
			end
		end
end

function Me:AddSchedule(after,script)
	if debug.scheduler then Me:Debug("called AddSchedule for "..after..","..script) end
	local at=ElapsedTime+after
	for i=1,#Schedules,1 do
		if Schedules[i][1]>at then
			if debug.scheduler then Me:Debug("Scheduler inserting after "..i..": at "..format("%u",at).." (now="..format("%u",ElapsedTime).."), "..script) end
			tinsert(Schedules,i,{at,script})
			break
		end
	end
end

function Me:DelSchedule(script)
	for i=1,#Schedules,1 do
		if Schedules[i] and Schedules[i][2]==script then 
			if debug.scheduler then Me:Debug("Scheduler deleting "..Schedules[i][1]..", "..script) end
			tremove(Schedules,i)
		end
	end
end

function Me:Schedule(reminder)
	local seconds,command=strsplit(" ",reminder,2)
	seconds=tonumber(seconds)
	if not seconds or not reminder then 
		Me:Print(L.msg.scheduleformat,nil,"ERROR")
	else  
		Me:AddSchedule(seconds,"Me:Print(\""..reminder.."\",nil,\"REMINDER\")") 
	end
end

-- -----------------------------------------------------------------
-- SLASH COMMANDS
-- -----------------------------------------------------------------
function Me:Slash(parm)
	if debug.div then Me:Debug("slash command '"..(cmd or "nil").."', parms '"..(rest or "nil").."'") end
	local i=strfind(parm.." "," ")
	local cmd=strlower(strtrim(strsub(parm,1,i)))
	local rest=strtrim(strsub(parm,i))
	if parm=="" then GUI:Route("Reactions")
	elseif cmd=="re-initialize" then 
		PrattleDB=defaultPrattleDB
		PrattleDBpC=defaultPrattleDBpC
		Me:Initialize()
	elseif cmd=="hello"		then Me:Emotor("HELLO",rest)
	elseif cmd=="bye"       then Me:Emotor("BYE",rest)
	elseif cmd=="thanks"    then Me:Emotor("THANK",rest)
	elseif cmd=="sorry"		then Me:Emotor("SORRY",rest)
	elseif cmd=="pet"		then Me:PetControl(rest)
	elseif cmd=="schedule"	then Me:Schedule(rest)
	elseif cmd=="sound"		then Me:Sound(rest)
	elseif cmd=="list"		then Me:List(rest)
	elseif cmd=="debug"		then
		local onoff,item=strsplit(" ",strlower(strtrim(rest)),2)
		local set="error"
		if (onoff or "on")=="on" or(onoff or "nil")=="off" then set=strupper((onoff or "on")) end
		local items={"cast","regen","text","sex","scheduler","div","gui"}
		local setcount=0
		for i=1,#items,1 do
			if (item or items[i])==items[i] and set~=error then 
				debug[items[i]]=(set=="ON")
				if items[i]=="scheduler" then debug.schedule={begin=ElapsedTime,calls=0} end
				setcount=setcount+1
			end
			if debug[items[i]] then Me:Print("Debug ON "..items[i]) else Me:Print("Debug OFF "..items[i]) end
		end
		if setcount==0 then 
			Me:Print("Syntax: debug on | off [ cast | regen | text | sex | scheduler | div | gui ]") 
		else
			GUI:SetDebug(debug.gui)
		end
	else 
		Me:Emotor(strlower(cmd,rest))
	end
end

-- -----------------------------------------------------------------
-- EVENT TARGET CHANGED
-- -----------------------------------------------------------------
function Me:PLAYER_TARGET_CHANGED()
	if UnitExists("target") then
		if not UnitIsPlayer("target") then dummy=Me:GetSex(UnitName("target")) -- nur zur Feststellung, ob die SEXsufix Tabelle vollständig ist
		else
			lasttarget=lasttarget+1
			name=UnitName("target")
			if PrattleDBpC.LASTTARGETS[name]==nil then PrattleDBpC.LASTTARGETS[name]={} end
			local faction=UnitFactionGroup("target")
			local guild=(GetGuildInfo("target") or "")
			local lclass,class=UnitClass("target")
			local lrace,race=UnitRace("target")
			local sex=UnitSex("target")
			PrattleDBpC.LASTTARGETS[name]={last=PrattleDB.ALLTIME+ElapsedTime,faction=faction,guild=guild,class=lclass,race=(lrace or race),sex=sex}
		end
	end
end

-- -----------------------------------------------------------------
-- EVENT START SPELL CAST
-- -----------------------------------------------------------------
function Me:UNIT_SPELLCAST_START(who,spell,rank)
	if debug.cast then Me:Debug(who.." starts spell "..(spell or "nil").." with rank "..(rank or "nil")) end
	if who=="player" then
		if spell==L.spell.RESTSTONE then 					Me:ReactOn("RESTSTONE")										-- Ruhestein
		elseif spell==L.spell.FORTRESTSTONE then			Me:ReactOn("RESTSTONE")										-- Garnisonsruhestein
		elseif spell==L.spell.FIRE then 					Me:ReactOn("FIRE")											-- Lagerfeuer
		elseif strfind(spell,L.spell.MAGEPORTAL)==1 then	Me:ReactOnMagePortal(spell,"PORTAL")						-- Magier Teleport
		elseif strfind(spell,L.spell.MAGETELEPORT)==1 then	Me:ReactOnMagePortal(spell,"TELEPORT")						-- Magier Teleport
		elseif spell==L.spell.HERBAL then					Me:ReactOn("HERBAL")										-- Kräuter sammeln
		elseif spell==L.spell.MINING then					Me:ReactOn("MINING")										-- Bergbau
		elseif spell==L.spell.SKINNING then					Me:ReactOn("SKINNING")										-- Kürschnern
		else
			for i=1,#L.spell.RESURRECT,1 do
				if spell==L.spell.RESURRECT[i] then			Me:ReactOn("RESURRECT")										-- Wiederbelebung
				end
			end
			for i=1,#L.spell.SUMMON,1 do
				if spell==L.spell.SUMMON[i].text then		Me:ReactOnSummon(L.spell.SUMMON[i].creature)				-- Begleiter beschwören
				end
			end
		end
	end
end

-- -----------------------------------------------------------------
-- EVENT SPELL CAST SUCCEEDED
-- -----------------------------------------------------------------
function Me:UNIT_SPELLCAST_SUCCEEDED(who,spell,rank)
	if debug.cast then Me:Debug(who.." succeeds with spell "..(spell or "nil").." with rank "..(rank or "nil")) end
	if who=="player" then
		if spell==L.spell.SOULSTONE then					Me:ReactOnSoulstone()
		else
			for i=1,#L.spell.SUMMON,1 do
				if spell==L.spell.SUMMON[i].text then		Me:ReactOnSummon(L.spell.SUMMON[i].creature,true)			-- Begleiter beschwören
				end
			end
		end
	end
end

-- -----------------------------------------------------------------
-- EVENT START SPELL CAST CHANNELED
-- -----------------------------------------------------------------
function Me:UNIT_SPELLCAST_CHANNEL_START(who,spell,rank)
	if debug.cast then Me:Debug(who.." starts channeled spell "..(spell or "nil").." with rank "..(rank or "nil")) end
	if who=="player" then
		if spell==L.spell.WARLOCKPORTAL then				Me:ReactOn("WARLOCKPORTAL","PORTAL")	-- (Hexer) Portal
		elseif spell==L.spell.PORTALSTONE then				Me:ReactOn("PORTALSTONE","PORTAL")		-- Beschwörungsstein
		elseif spell==L.spell.FISHING then					Me:ReactOnFishing()						-- Angeln
		end
	end
end

-- -----------------------------------------------------------------
-- EVENT STOP SPELL CAST CHANNELED
-- -----------------------------------------------------------------
function Me:UNIT_SPELLCAST_CHANNEL_STOP(who,spell,rank)
	if debug.cast then Me:Debug(who.." stops channeled spell "..(spell or "nil").." with rank "..(rank or "nil")) end
end

-- -----------------------------------------------------------------
-- EVENT BEGIN FIGHT
-- -----------------------------------------------------------------
function Me:PLAYER_REGEN_DISABLED()
	if debug.regen then Me:Debug("fight starting") end
end

-- -----------------------------------------------------------------
-- EVENT END FIGHT
-- -----------------------------------------------------------------
function Me:PLAYER_REGEN_ENABLED()
	if debug.regen then Me:Debug("fight ended") end
end

-- -----------------------------------------------------------------
-- LIST NOSEX, TARGETS, SCHEDULER
-- -----------------------------------------------------------------
function Me:List(list)
	if not list then Me:Print("L.msg.missingparm")
	elseif strsub(strupper(list),1,5)=="RESET" then
		local reset,list=strsplit(" ",2)
		list=strupper(strtrim(list))
		if list=="UNKNOWN" then PrattleDB.NOSEXFOUND={}
		elseif list=="TARGETS" then PrattleDBpC.LASTTARGETS={}
		else Me:Print("L.msg.invalidparm")
		end
	elseif strupper(list)=="UNKNOWN" then
		for name,data in pairs(PrattleDB.NOSEXFOUND) do 
			Me:Print(Me:hhmmss(PrattleDB.ALLTIME+ElapsedTime-data.last)..": "..data.count.."x "..name) 
		end
	elseif strupper(list)=="TARGETS" then
		for name,info in pairs(PrattleDBpC.LASTTARGETS) do 
			local age=Me:hhmmss(PrattleDB.ALLTIME+ElapsedTime-(info.last or 0))
			Me:Print(age..": "..name..", "..info.faction..", "..info.guild..", "..info.class..", "..info.race..", "..L.sex[info.sex])
		end
	elseif strupper(list)=="SCHEDULES" then
		for s=1,#Schedules,1 do Me:Print((Schedules[s][1]-ElapsedTime).."s: "..Schedules[s][2]) end
	end
end

-- -----------------------------------------------------------------
-- REACT ON FISHING
-- -----------------------------------------------------------------
function Me:ReactOnFishing()
	-- ermitteln, ob Erst- oder Folgewurf, entsprechend reagieren
	if debug.cast then Me:Debug("react on FISHING = "..(PrattleDBpC.reactOn.FISHING or "nil")) end
	if PrattleDBpC.reactOn.FISHING>=math.random(100) then Me:Emotor("FISHING") end
end

-- -----------------------------------------------------------------
-- REACT ON MAGE TELEPORT
-- -----------------------------------------------------------------
function Me:ReactOnMagePortal(spell,keyword)
	if debug.cast then Me:Debug("react on "..spell.." = "..(PrattleDBpC.reactOn[keyword] or "nil")) end
	local city=strtrim(strsub(spell,strfind(spell,":")+1))
	if PrattleDBpC.reactOn[keyword]>=math.random(100) then Me:Emotor("MAGE"..keyword,nil,nil,{{"city",city}}) end
end

-- -----------------------------------------------------------------
-- REACT ON SOULSTONE
-- -----------------------------------------------------------------
function Me:ReactOnSoulstone(resttime)
	if debug.cast then Me:Debug("reacting on soulstone, resttime="..(resttime or "nil")) end
	if not resttime then
		Me:DelSchedule("Me:ReactOnSoulstone(0)")
		Me:DelSchedule("Me:ReactOnSoulstone(1)")
		Me:DelSchedule("Me:ReactOnSoulstone(5)")
		Me:AddSchedule(15*60,"Me:ReactOnSoulstone(0)")
		Me:AddSchedule(14*60,"Me:ReactOnSoulstone(1)")
		Me:AddSchedule(10*60,"Me:ReactOnSoulstone(5)")
		Me:Print(L.msg.soulstoneset)
		if UnitInParty("target") or UnitInRaid("target") then
			if PrattleDBpC.reactOn.SOULSTONE>=math.random(100) then Me:Emotor("SOULSTONE") end
		end
	elseif resttime==0 then Me:Print(L.msg.soulstoneout,nil,"SOULSTONEOUT")
	else
		Me:Print(Me:gsub(L.msg.soulstonerest,"<minutes>",resttime),nil,"ERROR")
	end
end

-- -----------------------------------------------------------------
-- REACT ON DEMON SUMMON
-- -----------------------------------------------------------------
function Me:ReactOnSummon(creature,succeeded)
	if succeeded then setcreature=creature end
	if playerclass=="HUNTER" or not succeeded then Me:PetControl("summon",creature) end
end

-- -----------------------------------------------------------------
-- GENERIC REACT ON ...
-- -----------------------------------------------------------------
function Me:ReactOn(keyword,randname)
	if debug.cast then Me:Debug("react on "..(keyword or "nil").." = "..(PrattleDBpC.reactOn[(randname or keyword)] or "nil")) end
	if PrattleDBpC.reactOn[(randname or keyword)]>=math.random(100) or debug.sex or debug.text then Me:Emotor(keyword) end
end

-- -----------------------------------------------------------------
-- PET CONTROL
-- -----------------------------------------------------------------
function Me:PetControl(action,creature)
	if not UnitExists("pet") and action~="summon" then Me:Print(L.msg.nopet,nil,"ERROR")
	else
		local key=nil
		if action=="summon" then 		key="SUMMON"
		elseif action=="dismiss" then	key="DISMISS"
		elseif action=="follow" then	key="FOLLOW"
		elseif action=="stay" then 		key="STAY"
		elseif action=="passive" then 	key="PASSIVE"
		elseif action=="attack" then 
			if UnitExists("target") and UnitCanAttack("target","player") then
				key="ATTACK"
			else
				Me:Print(L.msg.noattackabletarget,nil,"ERROR")
			end
		else
			Me:Print(Me:gsub(L.msg.unknownparm,"<parm>",action),nil,"ERROR")
		end
		if key~=nil then
			local wkey="DEMON"..key
			local pkey="PET"..key
			local petname=PrattleDBpC.PET[creature] or creature or UnitName("pet")
			if playerclass=="WARLOCK" and PrattleDB.emotor[wkey] then key=wkey else key=pkey end
			if (PrattleDBpC.reactOn[key] or PrattleDBpC.reactOn[pkey])>=math.random(100) then Me:Emotor(key,nil,nil,{{"pet",petname}}) end
		end
	end
end

-- -----------------------------------------------------------------
-- EMOTOR
-- -----------------------------------------------------------------
function Me:Emotor(tablename,tgtcat,onlyaction,moregsub)
	if debug.text then Me:Debug("emotor for "..(tablename or "nil")..", "..(tgtcat or "nil")..", "..(onlyaction or "nil")) end
	if tgtcat==nil or tgtcat=="" then
		tgtcat="NOTARGET"
		if UnitExists("target") then
			tgtcat="UNKNOWN"
			if UnitCanAttack("target","player") then tgtcat="ENEMY" end
			if UnitIsPlayer("target") then
				local name=UnitName("target")
				local info=PrattleDB.PERSONS[name]
				if info then
					if info[playername] then tgtcat=info[playername] end
				end
			end
		end
	end
	local doemo,dosay,language=Me:SelectEmoSay(tablename,tgtcat)
	-- TODO: ggf. Schlüssel <.race> definieren und durch charbezogenes Wort ersetzen (z.B. "Langohr" für Elfen)
	if moregsub then
		for m=1,#moregsub,1 do
			if debug.text then Me:Debug("emotor gsub '"..(moregsub[m][1] or "nil").."' into '"..(moregsub[m][2] or "nil").."'") end
			doemo=Me:gsub(doemo,"<"..moregsub[m][1]..">",moregsub[m][2])
			if debug.text then Me:Debug("after gsub: emo='"..doemo.."'") end
			dosay=Me:gsub(dosay,"<"..moregsub[m][1]..">",moregsub[m][2])
			if debug.text then Me:Debug("after gsub: say='"..dosay.."'") end
		end
	end
	if doemo and onlyaction~="say" then Me:Emote(doemo) end
	if dosay and onlyaction~="emote" then Me:Say(dosay,language) end
end

-- -----------------------------------------------------------------
-- EMOTE ausgeben
-- -----------------------------------------------------------------
function Me:Emote(emo)
	if debug.text then Me:Debug("emoting '"..emo.."'") end
	if string.sub(emo,1,1)=="/" then 
		DoEmote(string.sub(emo,2))
	else
		SendChatMessage(emo,"EMOTE")
	end
end

-- -----------------------------------------------------------------
-- SAY Text ausgeben
-- -----------------------------------------------------------------
function Me:Say(text,language)
	if debug.text then Me:Debug("saying '"..(text or "nil").."'") end
	local channel="SAY"
	if strlower(strsub(text,1,3))=="/y " then
		text=strtrim(strsub(text,3))
		channel="YELL"
	end
	SendChatMessage(text,channel,GetLanguageByIndex(language or 1))
end

-- -----------------------------------------------------------------
-- SELECT EMOTE AND SAY
-- -----------------------------------------------------------------
function Me:SelectEmoSay(tablename,tgtcategory)
	if debug.text then Me:Debug("select emo/say from "..(tablename or "nil")..", "..(tgtcategory or "nil")) end
	local say=nil
	local language=nil
	local emo=nil
	local dummy=nil
	if not PrattleDB.emotor[tablename] then Me:Print(Me:gsub(L.msg.undeftbl,"<table>",tablename),nil,"ERROR")
	else
		if PrattleDB.emotor[tablename]["NOCAT"] then tgtcategory="NOCAT" end
		if not PrattleDB.emotor[tablename][tgtcategory] then Me:Print(Me:gsub(Me:gsub(L.msg.undefcat,"<cat>",tgtcategory),"<table>",tablename),nil,"ERROR")
		else
			say,language=Me:RandomSelect(PrattleDB.emotor[tablename][tgtcategory].say)
			say=Me:ReplaceKeysWithSex(say)
			local i=strfind(say,"&&")
			if i then
				emo=strsub(say,i+2)
				if i>1 then say=strsub(say,1,i-1) else say="" end
			else
				emo,dummy=Me:RandomSelect(PrattleDB.emotor[tablename][tgtcategory].emo)
				emo=Me:ReplaceKeysWithSex(emo)
			end
		end
	end
	if debug.text then Me:Debug("selected say='"..(say or "nil").."'") end
	if debug.text then Me:Debug("selected emo='"..(emo or "nil").."'") end
	return emo,say,language
end

-- -----------------------------------------------------------------
-- SELECT RANDOM ENTRY FROM TABLE
-- -----------------------------------------------------------------
function Me:RandomSelect(list)
	local mylist={}
	for i=1,#list,1 do
		if list[i][playername] or 1==1 then 
			mylist[#mylist+1]={text=list[i].text,language=list[i][playername]}
		end
	end
	if #mylist==0 then mylist[1]={text="",language=0} end
	local s=math.random(#mylist)
	if debug.text then Me:Debug("selected from "..#mylist.." entries: '"..(mylist[s].text or "nil").."'") end
	return mylist[s].text,mylist[s].language
end

-- -----------------------------------------------------------------
-- REPLACE SPECIAL-KEYS IN GIVEN TEXT
-- -----------------------------------------------------------------
function Me:ReplaceKeysWithSex(text)
	local playersex=UnitSex("player")	
	local targetsex=playersex
	local targetname=playername
	local cursorsex=playersex
	local cursorname=playername
	-- Geschlecht des Targets ermitteln
	if UnitExists("target") then 
		targetsex=UnitSex("target") 
		targetname=Me:Peal(UnitName("target"))
		if targetsex==1 then Me:GetSex(targetname) end -- sächlich, ist default für alle Kreaturen
	end
	
	-- Geschlecht des Cursorziels ermitteln
	cursorname=getglobal("GameTooltipTextLeft1"):GetText()
	if cursorname==nil then 
		cursorname=targetname 
		cursorsex=targetsex
	else
		cursorname=Me:Peal(cursorname)
		cursorsex=Me:GetSex(cursorname)
	end

	if debug.sex then
		Me:Debug("player is "..(playername or "nil")..", sex "..(L.sex[playersex] or "nil"))
		Me:Debug("target is "..(targetname or "nil")..", sex "..(L.sex[targetsex] or "nil"))
		Me:Debug("cursor is "..(cursorname or "nil")..", sex "..(L.sex[cursorsex] or "nil"))
	end

	-- Namen im Text ersetzen
	text=(text or "")
	text=Me:gsub(text,"<*>",playername)
	text=Me:gsub(text,"<.>",targetname)
	text=Me:gsub(text,"<#>",cursorname)

	-- Schlüsselworte im Text ersetzen
	for key,repl in pairs(PrattleDB.HeSheIt) do
		text=Me:gsub(text,"<*"..key..">",repl[playersex])
		text=Me:gsub(text,"<."..key..">",repl[targetsex])
		text=Me:gsub(text,"<#"..key..">",repl[cursorsex])
	end
	return text
end

-- -----------------------------------------------------------------
-- PEAL PREFIX AND SUFIX FROM NAME
-- -----------------------------------------------------------------
function Me:Peal(name)
	if debug.text or debug.sex then Me:Debug("name before erase prefix is "..name) end
	-- Prefix entfernen ("Alter" "Junger" etc)
	local prefix,rest=strsplit(" ",name,2)
	if rest then
		local erase=L.erasePrefix
		for i=1,#erase,1 do
			if strlower(prefix)==erase[i] then name=rest end
			if debug.text then Me:Debug("prefix='"..prefix.."', erase='"..erase[i].."', name='"..name.."'") end
		end
		if debug.text or debug.sex then Me:Debug("name after erase prefix is "..name) end
	end
--	local parse={strsplit(" ",name)}
--	if #parse==2 then name=parse[2] end

	if debug.text or debug.sex then Me:Debug("cursor before erase sufix is "..name) end
	-- Suffix entfernen ("vorkommen", "pflanze", "ader"...)
	local erase=L.eraseSufix
	for i=1,#erase,1 do
		if strsub(name,strlen(name)-strlen(erase[i])+1)==erase[i] then
			name=strsub(name,1,strlen(name)-strlen(erase[i]))
		end
	end
	return name
end

-- -----------------------------------------------------------------
-- GET SEX
-- -----------------------------------------------------------------
function Me:GetSex(target,initcheck)
	local sex=1 -- Default ist sächlich
	local found=nil
	local word1,word2=strsplit(" ",strlower(target),2)
	if debug.sex then Me:Debug("identify sex for '"..(target or "nil").."'") end
	if UnitName("pet")==target then
		sex=2 -- Pets sind normalerweise männlich, außer Sukkubus
		if UnitCreatureFamily("pet")==L.SUKKUBUS then sex=3 end
		if debug.sex then Me:Debug("identified as pet with sex="..sex) end
		found=true
	end
	-- vorangestellte Worte durchsuchen (z.B. Drache der ..., Akolyth der...)
	if word2 and not found then
		local search=L.SEXprefix
		for i=1,#search,1 do
			if strfind(word1,search[i][2])==1 and not found then
				found="yes"
				sex=search[i][1]
				if debug.sex then Me:Debug("'"..word1.."' identified as "..i..":'"..search[i][2].."' = "..L.sex[sex]) end
			end
		end
		search=L.SEXsufix
		for i=1,#search,1 do
			if strsub(word1,strlen(word1)-strlen(search[i][2])+1)==search[i][2] and not found then
				found="yes"
				sex=search[i][1]
				if debug.sex then Me:Debug("'"..word1.."' identified as "..i..":'..."..search[i][2].."' = "..L.sex[sex]) end
			end
		end
	end
	-- Wortendungen durchsuchen
	word2=strlower(target)
	search=L.SEXsufix
	for i=1,#search,1 do
		if strsub(word2,strlen(word2)-strlen(search[i][2])+1)==search[i][2] and not found then
			found="yes"
			sex=search[i][1]
			if debug.sex then Me:Debug("'"..word2.."' identified as "..i..":'..."..search[i][2].."' = "..L.sex[sex]) end
		end
	end
	if not found then
		if not PrattleDB.NOSEXFOUND[target] or debug.sex then Me:Print(Me:gsub(L.msg.nosexfound,"<target>",target),nil,"ERROR") end
		if not initcheck then 
			if not PrattleDB.NOSEXFOUND[target] then PrattleDB.NOSEXFOUND[target]={last=0,count=0} end
			PrattleDB.NOSEXFOUND[target]={last=PrattleDB.ALLTIME+ElapsedTime,count=(PrattleDB.NOSEXFOUND[target].count or 0)+1} 
		end
	else
		if initcheck then
			Me:Debug(Me:gsub(Me:gsub(L.msg.gotsexfor,"<target>",target),"<sex>",L.sex[sex]))
			PrattleDB.NOSEXFOUND[target]=nil 
		end
		if debug.sex then Me:Debug("identified "..(target or "nil").." as sex "..(L.sex[sex] or "nil")) end
	end
	if initcheck then sex=found end
	return sex
end

function Me:gsub(text,search,replacement)
	local searchlen=strlen(search)
	local i=0
	while i<strlen(text) do
		if strsub(text,i,i+searchlen-1)~=search then i=i+1
		else
			if debug.text then Me:Debug("replacing '"..search.."' by '"..replacement.."' at "..i.." in '"..text.."'") end
			text=strsub(text,1,i-1)..replacement..strsub(text,i+searchlen)
			if debug.text then Me:Debug("resulted in '"..text.."'") end
			i=i+strlen(replacement)
		end
	end
	return text
--	local result,ignore=gsub(text,search,replacement)
--	return result
end

function Me:hhmmss(seconds)
	ss="0"..math.floor(seconds)%60
	mm="0"..math.floor(seconds/60)%60
	hh="0"..math.floor(seconds/3600)
	return strsub(hh,strlen(hh)-1)..":"..strsub(mm,strlen(mm)-1)..":"..strsub(ss,strlen(ss)-1)
end

-- -----------------------------------------------------------------
-- Simple I/O routines
-- -----------------------------------------------------------------
function Me:Print(text,color,soundname) -- color im Format "c=rrggbb00"
	if strsub(color or "",1,2)=="c=" then text="(color='"..strsub(color,3).."')"..text end
	DEFAULT_CHAT_FRAME:AddMessage("|cffddbb00Prattle:|r "..text)
	if soundname~=nil then Me:Sound(soundname) end
end

function Me:Debug(text)
	DEFAULT_CHAT_FRAME:AddMessage("|cff997700Prattle:|r |cff888888"..text.."|r")
end

function Me:Sound(nameornumber)
	local play=nameornumber
	if play then 
		if sound[nameornumber] then play=sound[nameornumber] end
		PlaySound(play) 
	end
end
